module Shifter where
import PreludeExt
import Input 
import Array


default_value = (0,0) 

cssetup::[[String]]-> (Int , Int, Array Int (Int,Int))
cssetup linestorage =
    cssetup_aux 0 0 circ_index_0

    where 
      circ_index_0 = array (0,numcslines) [(i, default_value) | i <- [0..numcslines]]

      numlines = length linestorage

      numcslines = allwords linestorage 
          where
            allwords ls = allwords_aux ls 0
                where  
                  allwords_aux [] sum = sum
                  allwords_aux (e:r) sum = allwords_aux r (sum + length e)
	    
      cssetup_aux cslineno lineno circ_index= 
          if lineno /= numlines
          then 
              let aux2 cslineno_arg wordno circ_index = 
	              if wordno /= numwords
	              then  aux2 (cslineno_arg + 1) (wordno + 1) (circ_index//[(cslineno_arg,(lineno, wordno))])
		      else (cslineno_arg, circ_index)
                          
                          where  
                            numwords = length (nth linestorage lineno)        
	      in 
                let (cslineno', circ_index') = aux2 cslineno 0 circ_index
	        in
	          cssetup_aux cslineno' (lineno + 1) circ_index'
          else (cslineno, lineno, circ_index)
    


